unit Unit1;
{
Obviously, you should have at least two installed
keyboard layouts on the system!

e-mail with suggestion, remarks etc. would be
really appreciated}
mailto:MilicT@Yahoo.com
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TMKeyboardLayoutCB;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Panel1: TPanel;
    TMKeyboardLayoutCB1: TTMKeyboardLayoutCB;
    TMKeyboardLayoutCB2: TTMKeyboardLayoutCB;
    procedure FormCreate(Sender: TObject);
    procedure TMKeyboardLayoutCB1Change(Sender: TObject;
      var CanChange: Boolean);
    procedure TMKeyboardLayoutCB1LanguageChange(Sender: TObject;
      OldKeyboardLayout, NewKeyboardLayout: HKL);
    procedure TMKeyboardLayoutCB1SubLanguageChange(Sender: TObject;
      OldSubLanguageID, NewSubLanguageID: Integer);
    procedure Memo1Enter(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure TMKeyboardLayoutCB2LanguageChange(Sender: TObject;
      OldKeyboardLayout, NewKeyboardLayout: HKL);
    procedure TMKeyboardLayoutCB2SubLanguageChange(Sender: TObject;
      OldSubLanguageID, NewSubLanguageID: Integer);
    procedure TMKeyboardLayoutCB2Change(Sender: TObject;
      var CanChange: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses ShellApi;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
Memo1.Lines.Clear;
Memo2.Lines.Clear;
end;

procedure TForm1.TMKeyboardLayoutCB1Change(Sender: TObject;
  var CanChange: Boolean);
begin
//     CanChange := true;
// uncomment the previous line if you want
// your KeyboardLayout to be really changed !!
Memo1.Lines.Clear;
Memo1.Lines.Add('Keyboard');
Memo1.Lines.Add('');
Memo1.Lines.Add('Layout         '+TMKeyboardLayoutCB1.Keyboard.Layout);
Memo1.Lines.Add('Language       '+TMKeyboardLayoutCB1.Keyboard.Language);
Memo1.Lines.Add('PhysicalLayout '+TMKeyboardLayoutCB1.Keyboard.PhysicalLayout);
Memo1.Lines.Add('LanguageID     '+IntToStr(TMKeyboardLayoutCB1.Keyboard.LanguageID));
Memo1.Lines.Add('SubLanguageID  '+IntToStr(TMKeyboardLayoutCB1.Keyboard.SubLanguageID));
Memo1.Lines.Add('LayoutFile     '+TMKeyboardLayoutCB1.Keyboard.LayoutFile);
Memo1.Lines.Add('*************');
Memo1.Lines.Add('Locale');
Memo1.Lines.Add('');
Memo1.Lines.Add('LanguageID          '+TMKeyboardLayoutCB1.Locale.LanguageID);
Memo1.Lines.Add('LanguageLocName     '+TMKeyboardLayoutCB1.Locale.LanguageLocName);
Memo1.Lines.Add('LanguageEnName      '+TMKeyboardLayoutCB1.Locale.LanguageEnName);
Memo1.Lines.Add('LanguageAbbName     '+TMKeyboardLayoutCB1.Locale.LanguageAbbName);
Memo1.Lines.Add('LanguageNativeName  '+TMKeyboardLayoutCB1.Locale.LanguageNativeName);

Memo1.Lines.Add('CountryCode         '+TMKeyboardLayoutCB1.Locale.CountryCode);
Memo1.Lines.Add('CountryLocName      '+TMKeyboardLayoutCB1.Locale.CountryLocName);
Memo1.Lines.Add('CountryEnName       '+TMKeyboardLayoutCB1.Locale.CountryEnName);
Memo1.Lines.Add('CountryAbbName      '+TMKeyboardLayoutCB1.Locale.CountryAbbName);
Memo1.Lines.Add('CountryNativeName   '+TMKeyboardLayoutCB1.Locale.CountryNativeName);

Memo1.Lines.Add('DefLanguageId       '+TMKeyboardLayoutCB1.Locale.DefLanguageId);
Memo1.Lines.Add('DefCountryCode      '+TMKeyboardLayoutCB1.Locale.DefCountryCode);
Memo1.Lines.Add('DefOEMCodePage      '+TMKeyboardLayoutCB1.Locale.DefOEMCodePage);
Memo1.Lines.Add('DefANSICodePage     '+TMKeyboardLayoutCB1.Locale.DefANSICodePage);
Memo1.Lines.Add('DefMACCodePage      '+TMKeyboardLayoutCB1.Locale.DefMACCodePage);

Memo1.Lines.Add('*************');

end;

procedure TForm1.TMKeyboardLayoutCB1LanguageChange(Sender: TObject;
  OldKeyboardLayout, NewKeyboardLayout: HKL);
begin
ShowMessage('Language Change');
Memo1.Tag := Integer(NewKeyboardLayout);
end;

procedure TForm1.TMKeyboardLayoutCB1SubLanguageChange(Sender: TObject;
  OldSubLanguageID, NewSubLanguageID: Integer);
begin
ShowMessage('Sub Language Change');

end;

procedure TForm1.Memo1Enter(Sender: TObject);
begin
If TWinControl(Sender).Tag <> 0
then Begin
     ActivateKeyboardLayout(HKL(TWinControl(Sender).Tag),0);
     End;
end;

procedure TForm1.Memo1Exit(Sender: TObject);
begin
ActivateKeyboardLayout(Screen.DefaultKbLayout,0);
end;

procedure TForm1.TMKeyboardLayoutCB2LanguageChange(Sender: TObject;
  OldKeyboardLayout, NewKeyboardLayout: HKL);
begin
ShowMessage('Language Change');
Memo2.Tag := Integer(NewKeyboardLayout);
end;

procedure TForm1.TMKeyboardLayoutCB2SubLanguageChange(Sender: TObject;
  OldSubLanguageID, NewSubLanguageID: Integer);
begin
ShowMessage('Sub Language Change');
end;

procedure TForm1.TMKeyboardLayoutCB2Change(Sender: TObject;
  var CanChange: Boolean);
begin
Memo2.Lines.Clear;
Memo2.Lines.Add('Keyboard');
Memo2.Lines.Add('');
Memo2.Lines.Add('Layout         '+TMKeyboardLayoutCB2.Keyboard.Layout);
Memo2.Lines.Add('Language       '+TMKeyboardLayoutCB2.Keyboard.Language);
Memo2.Lines.Add('PhysicalLayout '+TMKeyboardLayoutCB2.Keyboard.PhysicalLayout);
Memo2.Lines.Add('LanguageID     '+IntToStr(TMKeyboardLayoutCB2.Keyboard.LanguageID));
Memo2.Lines.Add('SubLanguageID  '+IntToStr(TMKeyboardLayoutCB2.Keyboard.SubLanguageID));
Memo2.Lines.Add('LayoutFile     '+TMKeyboardLayoutCB2.Keyboard.LayoutFile);
Memo2.Lines.Add('*************');
Memo2.Lines.Add('Locale');
Memo2.Lines.Add('');
Memo2.Lines.Add('LanguageID          '+TMKeyboardLayoutCB2.Locale.LanguageID);
Memo2.Lines.Add('LanguageLocName     '+TMKeyboardLayoutCB2.Locale.LanguageLocName);
Memo2.Lines.Add('LanguageEnName      '+TMKeyboardLayoutCB2.Locale.LanguageEnName);
Memo2.Lines.Add('LanguageAbbName     '+TMKeyboardLayoutCB2.Locale.LanguageAbbName);
Memo2.Lines.Add('LanguageNativeName  '+TMKeyboardLayoutCB2.Locale.LanguageNativeName);

Memo2.Lines.Add('CountryCode         '+TMKeyboardLayoutCB2.Locale.CountryCode);
Memo2.Lines.Add('CountryLocName      '+TMKeyboardLayoutCB2.Locale.CountryLocName);
Memo2.Lines.Add('CountryEnName       '+TMKeyboardLayoutCB2.Locale.CountryEnName);
Memo2.Lines.Add('CountryAbbName      '+TMKeyboardLayoutCB2.Locale.CountryAbbName);
Memo2.Lines.Add('CountryNativeName   '+TMKeyboardLayoutCB2.Locale.CountryNativeName);

Memo2.Lines.Add('DefLanguageId       '+TMKeyboardLayoutCB2.Locale.DefLanguageId);
Memo2.Lines.Add('DefCountryCode      '+TMKeyboardLayoutCB2.Locale.DefCountryCode);
Memo2.Lines.Add('DefOEMCodePage      '+TMKeyboardLayoutCB2.Locale.DefOEMCodePage);
Memo2.Lines.Add('DefANSICodePage     '+TMKeyboardLayoutCB2.Locale.DefANSICodePage);
Memo2.Lines.Add('DefMACCodePage      '+TMKeyboardLayoutCB2.Locale.DefMACCodePage);

Memo2.Lines.Add('*************');

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    ShellExecute(GetDesktopWindow, 'open',
      PChar('mailto:MilicT@Yahoo.com'
      + '?subject=TMKeyboardLayoutCB demo'
      + '&body=Your comments would be really appreciated ! %0d%0a'
      + 'Can you afford to waste an e-mail and few minutes%0d%0a'
      + 'for quick remarks and suggestions, please? !%0d%0a%0d%0a'
      + 'Even if you don''t have any, tell me where are you from? !%0d%0a'
      + 'I am curious how far this component traveled !%0d%0aThanks in advance,'
      + '%0d%0aMilic Tomislav%0d%0ahttp://www.geocities.com/MilicT')
      , nil, nil, 1 {sw_Normal});
end;

end.
